/* 
 * File:   get_cabling_for_run.cpp
 * Author: martynia
 *
 * Created on August 8, 2016, 12:36 PM
 */

#include <iostream>
#include <cabling/cabling.h>
#include <exception>
#include <generated/CablingImplPortBinding.nsmap>

using namespace std;

/*
 * An example to run a cabling getter.
 * run with TOF1 2013-08-01 00:00:00 for example or with a non existent detector or run 
 * to see exceptions.
 */
int main(int argc, char** argv) {

    if (argc != 3) {
        std::cerr << " Please supply exactly 2 arguments: detector and timestamp e.g. \"2013-08-01 00:00:00\" " << std::endl;
        return 1;
    }

    MAUS::CDB::Cabling cabling; // define cabling with the default ws endpoint (production DB)
    //MAUS::CDB::Cabling cabling("http://localhost:78080/cdb/cabling"); // custom server
    std::string result;  // gets passed by reference and will hold the data from the server.
    try {
        std::string status;
        cabling.getStatus(status);
        std::cout << " Cabling status returned " << status << std::endl;        
        cabling.getDetectorCablingForDate(argv[1], argv[2], result);
        std::cout << result << "(" << result.size() << " characters)" << std::endl;

    } catch (std::exception &e) {
        std::cerr << e.what() << std::endl;
    }
    return 0;
}

